//---------------------------------------------------------------------------
#ifndef ShowTextH
#define ShowTextH
#include <vcl\inifiles.hpp>
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
//---------------------------------------------------------------------------
#include "TDummyForm.h"
//---------------------------------------------------------------------------
class TShowForm : public TForm
{
__published:	// IDE Ǘ̃R|[lg
    TMemo *ShowText;
    void __fastcall FormResize(TObject *Sender);
    void __fastcall DblClick(TObject *Sender);
private:	// [U[錾
    char * Header;
    TIniFile *IniFile; // Init@CNX̃GCAXÂTShowFormListŊǗB
    bool HideIfNoHeader;  // ꂪtruêƂAwb_ȂꍇWindowBB
    bool HideTaskBar;  // ꂪtruêƂ^XNo[̃ACR\ɂB
    TForm *Parent; //etH[
public:		// [U[錾
    TShowForm *Next;  // ̃XgvfB
	__fastcall TShowForm::TShowForm(TForm* Owner, TIniFile *IniFile, const char *PrmHeader);
	__fastcall TShowForm::~TShowForm();
	void __fastcall Initialize();  // RXgN^ōsȂsB
	inline const char * GetHeader(){return Header;};  // \ׂwb_ԋpB
    void __fastcall SetHeader(const char *);  // \ׂwb_ݒ肷B
    inline int Length(){return ShowText->Text.Length();};  // \̒ԋpB
    HWND SetParentWin(HWND);  // ewindoww肷B󂤂܂삵ĂȂB
    inline void SetHideIfNoHeader(bool flag){HideIfNoHeader = flag;};  // HideIfNoHeadertOݒ肷B
    inline bool IsMyWindowsHandle(HWND handle)  // w肳ꂽnhWindowHandleǂԋpB
              {return ((Handle == handle || ::IsChild(Handle, handle) != false)?true:false);};
    inline void SetFont(TFont &SrcFont){ShowText->Font->Assign(&SrcFont);};
    void __fastcall SetHideTaskBar(bool hide);
};
//---------------------------------------------------------------------------
extern TShowForm *ShowForm;
//---------------------------------------------------------------------------

// user define
class TShowFormList
{
private:
    TDummyForm *Dummy;// ^XNo[\p_~[EBhE
    int listcount;  // \wb_Xg̗vf
    TShowForm *List; // \wb_Xg̐擪vf
    TShowForm *Last;  // \wb_Xg̍ŏIvf
    TIniFile *IniFile; // ̃vOCŎgpĂinit@C̃IuWFNg
    bool AlwaysOnTop;  // uɈԏɕ\vIvV̒l
    bool HideTaskBar;  // if true hide taskbar-icon
    void __fastcall NewList();
    void __fastcall DeleteList();
    HWND hMain;  // Becky!̃CEBhEnh
    HWND hTree;  // Becky!̃c[r[EBhEnh
    HWND hList;  // Becky!̃Xgr[CEBhEnh
    HWND hView;  // Becky!̃[r[CEBhEnh
    long DebugNum;
    bool HideIfNoHeader;
    TFont *Font;
public:
    __fastcall TShowFormList(const char*);
    __fastcall ~TShowFormList();
    inline int count(){return listcount;};
    int __fastcall ShowHeader(LPCSTR lpMailID);
    void __fastcall SetProperty(const AnsiString&, const TCheckBoxState, const TCheckBoxState, const TCheckBoxState);
    void __fastcall Show();
    void __fastcall Hide();
    void __fastcall SetParentWin(HWND hMain);
    inline void SetParentWin(void){SetParentWin(hMain);};
    inline bool ShowAlwaysOnTop(){return AlwaysOnTop;};
    inline bool isHideIfNoHeader(){return HideIfNoHeader;};
    inline bool isHideTaskBar(){return HideTaskBar;};
    AnsiString &SetHeaderList(AnsiString &);
    inline HWND GetBeckyMain(){return hMain;};
    inline HWND GetBeckyTree(){return hTree;};
    inline HWND GetBeckyList(){return hList;};
    inline HWND GetBeckyView(){return hView;};
    bool __fastcall IsMyWindowsHandle(HWND);
    inline void SetFont(TFont &SrcFont){Font->Assign(&SrcFont);};
    void __fastcall SetHideTaskBar(bool hide);
    inline TFont* GetFont(){return Font;};
};

#endif
